#include "Confidence.h"

Confidence::Confidence(int *lastKey, UI *ui, unsigned validityLength) {
	queueLength = validityLength;
	Confidence::lastKey = lastKey;
	Confidence::ui = ui;
}

bool Confidence::check(std::vector<cv::Rect> contours) {
	bool consistent;
	confident.clear();

	if (*lastKey == 98) {
		drawBounds = !drawBounds;
	}

	for (unsigned rectangleID = 0; rectangleID < contours.size(); rectangleID++) {
		consistent = true;
		cv::Rect current = contours[rectangleID];

		for (unsigned frameID = 0; frameID < confidenceQueue.size(); frameID++) {
			if (confidenceQueue[frameID].size() == 0) {
				consistent = false;
				break;
			}
			for (unsigned frameRectID = 0; frameRectID < confidenceQueue[frameID].size(); frameRectID++) {
				cv::Rect previous = confidenceQueue[frameID][frameRectID];
				if ((current & previous).area() < 0.78*(current.area())) {
					consistent = false;
					break;
				}
			}
		}
		if (consistent) {
			confident.push_back(contours[rectangleID]);
		}
	}

	confidenceQueue.push_front(contours);
	if (confidenceQueue.size() > queueLength) {
		confidenceQueue.pop_back();
	}

	if (drawBounds) {
		drawBoundsOnMat(*(ui->originalFrame()));
	}

	return confident.size() != 0;
}

std::vector<cv::Rect> Confidence::rectangleBounds() const {
	return confident;
}

void Confidence::drawBoundsOnMat(cv::Mat &mat) {
	for (unsigned i = 0; i < confident.size(); i++) {
		cv::rectangle(mat, confident[i], boundColor, 1);
	}
}


Confidence::~Confidence() {
	// TODO Auto-generated destructor stub
}
