#include <iostream>

#include "Rectangle/ContourAnalyzer.h"
#include "webcam/Webcam.h"
#include "UI.h"
#include "Rectangle/Confidence.h"

int main(int argc, char** argv) {
	Webcam webcam = 0;
	int *lastKey = new int(0);
	UI *ui = new UI(lastKey);
	ContourAnalyzer ca{ui, lastKey};
	Confidence conf{lastKey, ui, 6};

	while (true) {
		webcam.update();
		cv::Mat frame = webcam.getFrame();
		ui->setOriginalFrame(frame);


		*lastKey = cv::waitKey(33);
		if (*lastKey != 255) {
			std::cout << "key pressed: " << *lastKey << std::endl;
			if (*lastKey == 27) {
				break;
			}
		}


		ca.analyze();
		ca.convertContoursToBounds();
		conf.check(ca.getBounds());
		ui->render();

		*lastKey = 255;
	}

	delete ui;
	delete lastKey;
	cv::destroyAllWindows();
	return 0;
}
